$$
({
	
	/*
	
	$$.transition
	({
		onscreenId : '#page1',
		offscreenId : '#page2',
		transitionType : 'shoveLeft', // shoveLeft, shoveRight, shoveUp, shoveDown
		duration : 750
	});
				
	*/
	
	transition : 
	{
		__construct : function(parms)
		{
			$$.transition.blockUi(parms);
			$$.transition.doTransition(parms);
		},
		
		blockUi : function()
		{
			$('body').append('<div id="ddUiBlocker" style="position: absolute; top: 0; left: 0; width: 100%; height: 100%; background: #fff; z-index: 10000000; opacity: 0;"></div>');	
			$('#ddUiBlocker').bind('touchmove touchstart click scroll',function(event)
			{
				event.preventDefault();
				$$.stopEvent(event);
				return false;
			});
		},

		doTransition : function(parms)
		{
			$(parms.offscreenId).show();
			
			switch(parms.transitionType)
			{
				case 'shoveLeft':
				
					$(parms.onscreenId).css({left:0,top:0});
					$(parms.offscreenId).css({left:$$.state.winWidth,top:0});

					$(parms.onscreenId).transition({ x: '-'+$$.state.winWidth+'px' },parms.duration,'cubic-bezier(.72,.48,.62,.82)',function()
					{
						$(this).transition({ x: '0px' },0);
						$(this).css({left:-$$.state.winWidth});
						$(this).hide();
					});
					$(parms.offscreenId).transition({ x: '-'+$$.state.winWidth+'px' },parms.duration,'cubic-bezier(.72,.48,.62,.82)',function()
					{
						$(this).transition({ x: '0px' },0);
						$(this).css({left:0});
						$$.transition.onComplete(parms);
					});
					break;
					
				case 'shoveRight':
				
					$(parms.onscreenId).css({left:0,top:0});
					$(parms.offscreenId).css({left:-$$.state.winWidth,top:0});

					$(parms.onscreenId).transition({ x: $$.state.winWidth+'px' },parms.duration,'cubic-bezier(.72,.48,.62,.82)',function()
					{
						$(this).transition({ x: '0px' },0);
						$(this).css({left:$$.state.winWidth});
						$(this).hide();
					});
					$(parms.offscreenId).transition({ x: $$.state.winWidth+'px' },parms.duration,'cubic-bezier(.72,.48,.62,.82)',function()
					{
						$(this).transition({ x: '0px' },0);
						$(this).css({left:0});
						$$.transition.onComplete(parms);
					});
					break;
					
				case 'shoveUp':
				
					$(parms.onscreenId).css({left:0,top:0});
					$(parms.offscreenId).css({left:0,top:$$.state.winHeight});

					$(parms.onscreenId).transition({ y: -$$.state.winHeight+'px' },parms.duration,'cubic-bezier(.72,.48,.62,.82)',function()
					{
						$(this).transition({ y: '0px' },0);
						$(this).css({top:-$$.state.winHeight});
						$(this).hide();
					});
					$(parms.offscreenId).transition({ y: -$$.state.winHeight+'px' },parms.duration,'cubic-bezier(.72,.48,.62,.82)',function()
					{
						$(this).transition({ y: '0px' },0);
						$(this).css({top:0});
						$$.transition.onComplete(parms);
					});
					break;
					
				case 'shoveDown':
				
					$(parms.onscreenId).css({left:0,top:0});
					$(parms.offscreenId).css({left:0,top:-$$.state.winHeight});

					$(parms.onscreenId).transition({ y: $$.state.winHeight+'px' },parms.duration,'cubic-bezier(.72,.48,.62,.82)',function()
					{
						$(this).transition({ y: '0px' },0);
						$(this).css({top:$$.state.winHeight});
						$(this).hide();
					});
					$(parms.offscreenId).transition({ y: $$.state.winHeight+'px' },parms.duration,'cubic-bezier(.72,.48,.62,.82)',function()
					{
						$(this).transition({ y: '0px' },0);
						$(this).css({top:0});	
						$$.transition.onComplete(parms);
					});
					break;
			}
		},
		
		onComplete : function(parms)
		{
			$('#ddUiBlocker').remove();
			
			if ( typeof parms.callback == 'function' )
			{
				parms.callback(parms);
			}
		}
	}
})