$$
({
	phoneGap :
	{
		
		initCallback : function() {},	
		
		init : function(initCallback)
		{
			
			if ( typeof initCallback == 'function' )
			{
				$$.phoneGap.initCallback = function()
				{
					$('.phoneGapWrapper').css('opacity',1);
					initCallback(); // Needs to call - navigator.splashscreen.hide();
				}
			}
			else
			{
				$$.phoneGap.initCallback = function()
				{
					$('.phoneGapWrapper').css('opacity',1);
					navigator.splashscreen.hide();
				}
			}
			
			// Get a handle on the file system
			if ( typeof LocalFileSystem != 'undefined' )
			{
				window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, $$.phoneGap.do.registerFileSystem, null);
			}
			else
			{
				$$.phoneGap.initCallback();
			}
		},
		
		do :
		{
			registerFileSystem : function(fileSystem)
			{
				// $$.phoneGap.fs.root
				// $$.phoneGap.fs.root.name
				// $$.phoneGap.fs.root.fullPath
				$$.phoneGap.fs = fileSystem;
				
				$$.phoneGap.initCallback();
			}
		},
		
		file :
		{

			/*
				$$.phoneGap.file.download
				({
					fromUrl : 'https://itunes.apple.com/us/app/shazam/id284993459?mt=8',
					toPath : $$.phoneGap.fs.root.fullPath+'/test.html,
					callbackSuccess : function(entry)
					{
						alert('Boo!');
					},
					callbackError : function(error)
					{
						alert(error.source);
						alert(error.target);
						alert(error.code);
					}
				});
			*/
			
			download : function(parms)
			{
				var fileTransfer = new FileTransfer();
				fileTransfer.download
				(
					encodeURI(parms.fromUrl),
					parms.toPath,
					function(entry) 
					{
						if ( typeof parms.callbackSuccess == 'function' )
						{
							parms.callbackSuccess(entry);
						}
					},
					function(error) 
					{
						if ( typeof parms.callbackError == 'function' )
						{
							parms.callbackError(error);
						}
						
					}
				);
			},
			
			/*
				$$.phoneGap.file.move
				({
					fromPath : $$.phoneGap.fs.root.fullPath+'/test.html,
					toDirHandle : $$.phoneGap.photoDir,
					callbackSuccess : function(entry)
					{
						alert('Boo!');
					},
					callbackError : function(error)
					{
						alert(error.source);
						alert(error.target);
						alert(error.code);
					}
				});
			*/
			
			move : function(parms)
			{
								
				// Get file entry fromPath
				window.resolveLocalFileSystemURI
				(
					parms.fromPath,
					function(fileEntry) // success
					{
						fileEntry.moveTo
						(
							parms.toDirHandle,
							parms.toName,
							function(newEntry) 
							{
								// Success 
								if ( typeof parms.callbackSuccess == 'function' )
								{
									parms.callbackSuccess(newEntry);
								}
							}, 
							function(error) 
							{
								// Fail
								if ( typeof parms.callbackError == 'function' )
								{
									parms.callbackError(newEntry);
								}
							}
						);
					}, 
					function() 
					{
						// Fail
					}
				);
			}	
		}
	}
})